<template>
  <div class="nav-container">
    <div
      class="nav-panel"
      :class="{
        'is-hide': hideTop,
        'is-sticky': sticky,
        'is-fixed': !withLinks,
        'is-open': sidebarMenu
      }"
    >
      <MainContainer class="container">
        <div class="nav-panel__row">
          <div class="nav-panel__left">
            <div class="nav-panel__logo">
              <nuxt-link :to="localePath('/')">
                <svg-icon name="logo_font" />
              </nuxt-link>
            </div>
          </div>
          <div class="nav-panel__center">
            <div class="hide-desktop">
              <div class="nav-panel__login">
                <nuxt-link to="/auth"
                  ><svg-icon name="login_mobile"
                /></nuxt-link>
              </div>
            </div>
            <div class="hide-mobile">
              <div v-if="withLinks" class="nav-panel__nav">
                <ul v-if="menu">
                  <li v-for="(item, index) in menu" :key="index">
                    <a :href="item.url" target="_blank" v-if="item.external">
                      {{ getMenuTitle(item) }}
                    </a>
                    <nuxt-link :to="localePath(item.url)" v-else>
                      {{ getMenuTitle(item) }}
                    </nuxt-link>
                  </li>
                </ul>
              </div>
            </div>
          </div>
          <div class="nav-panel__right">
            <Burger />
            <!-- <div class="nav-panel__login" style="display: none">
            <nuxt-link class="nav__link" :to="localePath('/Auth')">
              <img src="https://source.unsplash.com/450x450/?sony" alt="" />
            </nuxt-link>
          </div> -->
          </div>
        </div>
      </MainContainer>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, useAsync } from '@nuxtjs/composition-api'
import useSidebarMenu from '@/hooks/sidebar-menu'
import useGetLocales from '@/hooks/get-locales'
import getMenuTitle from '@/hooks/get-menu-title'

import MainContainer from '@/components/ui/MainContainer.vue'
import Burger from '@/components/ui/Burger.vue'

import { Menu_Type_Enum, MenuItemWithLocalizationFragment } from '@/sdk/types'
import { AppEvents } from '~/types'
import { useGetMenuItemsQuery } from '~/sdk/hooks'

export default defineComponent<{
  withLinks?: boolean
}>({
  name: 'Nav',
  props: ['withLinks'],
  components: { MainContainer, Burger },
  setup(_, { root }) {
    const { toggleSidebarMenu, sidebarMenu } = useSidebarMenu()
    const { onResult, refetch } = useGetMenuItemsQuery({
      types: [Menu_Type_Enum.Header],
      locales: useGetLocales(root.$i18n)
    })

    const menu = useAsync<MenuItemWithLocalizationFragment[]>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            resolve(result?.data?.menu ?? [])
          })
        )
    )

    if (process.client) {
      root.$on(AppEvents.LocaleChanged, () => {
        refetch({
          types: [Menu_Type_Enum.Header],
          locales: useGetLocales(root.$i18n)
        })
      })

      onResult(result => {
        menu.value = result?.data?.menu ?? []
      })
    }

    return {
      menu,
      getMenuTitle,
      toggleSidebarMenu,
      sidebarMenu
    }
  },
  data() {
    return {
      sticky: false,
      hideTop: false,
      scrollTop: 0,
      prevScrollTop: 0,
      headerHight: 0
    }
  },
  watch: {
    scrollTop(scrollTop, prevScrollTop) {
      const elem = this.$el as HTMLElement
      this.sticky = scrollTop > elem.offsetTop + 100
      this.hideTop = !(
        scrollTop < elem.offsetHeight || scrollTop < prevScrollTop
      )
    },

    hideTop: {
      immediate: true,
      handler(value) {
        this.hideTop = value
      }
    }
  },

  methods: {
    onWindowScroll() {
      this.scrollTop = (
        document.scrollingElement || document.documentElement
      ).scrollTop
    }
  },

  mounted() {
    // TODO: отрефакторь этот файл плиз, тут костыль какой-то который размеры окна меняет
    // @ts-ignore
    window.addEventListener('scroll', this.onWindowScroll)
  },
  beforeDestroy() {
    // @ts-ignore
    window.removeEventListener('scroll', this.onWindowScroll)
  }
})
</script>

<style lang="scss">
.nav-container {
  height: 60px;
  @media (min-width: 1199.98px) {
    padding: 30px 0 70px 0;
    height: 170px;
  }
}

.nav-panel {
  transition: transform 0.3s linear, background-color 0.3s linear;
  position: relative;
  z-index: 99;
  background: #3b435a;
  padding: 5px 0px;
  $self: &;

  @media (max-width: 1199.98px) {
    &.is-open {
      transform: translateY(0%) !important;
      background: #3b435a !important;
      left: 0;
      right: 0;
      top: 0;
      position: fixed;
    }
  }

  @media (min-width: 1199.98px) {
    background-color: rgba(#252d45, 0);
    padding: 10px 0;

    &.is-fixed {
      transform: translateY(0%) !important;
    }
  }

  &.is-sticky {
    position: fixed;
    left: 0;
    right: 0;
    top: 0;
    background-color: rgba(#272c3b, 1);
    &.is-fixed {
      background: #272c3b;
    }
  }
  &.is-hide {
    transform: translateY(-100%);
  }

  .container {
    margin: 0 auto;
    padding-left: 30px;
    padding-right: 30px;
  }

  &__row {
    display: flex;
    align-items: center;
    justify-content: space-between;
    height: 50px;
    font-size: 0px;
  }

  &__left {
    order: 2;
  }

  &__right {
    display: flex;
    align-items: center;
    justify-content: flex-end;
    order: 1;
    > * {
      margin-right: 60px;

      &:last-child {
        margin-right: 0;
      }
    }
  }

  &__center {
    order: 3;
  }

  &__logo {
    font-size: 0;
    a {
      display: inline-block;
      opacity: 0.5;
      transition: opacity 0.2s linear;

      &:hover {
        opacity: 1;
      }
    }

    svg {
      width: 70px;
      height: 25px;
      fill: #7683ad;
    }
  }

  &__nav {
    ul {
      margin: 0;
      padding: 0;
      list-style: none;
      display: grid;
      grid-auto-flow: column;
      grid-gap: 50px;
      justify-content: center;
      align-items: center;
      font-size: 0;

      li {
        a {
          letter-spacing: 0px;
          color: #ffffff;
          font-size: 24px;
          line-height: 33px;

          background-image: linear-gradient(
            0deg,
            currentColor 100%,
            rgba(32, 126, 150, 0)
          );
          background-size: 0 1px;
          padding-bottom: 2px;
          background-position: 200% 100%;
          background-repeat: no-repeat;
          transform-origin: left bottom;
          transition: opacity 0.2s linear, background-size 0.5s ease,
            background-position 0.6s ease-out 0.1s, color 0.5s linear;
          opacity: 0.5;
          &:hover {
            opacity: 1;
            background-size: 100% 1px;
            background-position: 0 100%;
            animation: underline-hover forwards;
            animation-duration: 0.3s;
          }
        }
      }
    }
  }

  &__login {
    a {
      display: inline-block;
    }
    img {
      width: 60px;
      height: 60px;
      border-radius: 50%;
      object-fit: cover;
    }
    svg {
      width: 30px;
      height: 24px;
      fill: #fff;
    }
  }
}

@media (min-width: 1199.98px) {
  .nav-panel {
    &__sticky {
      background-color: #252d45;
      padding: 10px 0px;
    }

    &__left {
      order: 1;
    }
    &__center {
      order: 2;
      flex: 1;
      padding-left: 20px;
      padding-right: 20px;
    }
    &__right {
      order: 3;
    }

    &__logo {
      svg {
        width: 100px;
        height: 35px;
        fill: #fff;
      }
    }

    &__menu {
      svg {
        width: 36px;
        height: 20px;
      }
    }
  }
}
</style>
